clc
clear
close all

%--------------------------------------------------------------------------
%   Proposal function q(s)
%--------------------------------------------------------------------------


global alpha beta delta grid N  s_m s_o s_r

alpha=0.4;

beta=0.96;

delta=0.5;

n = delta*alpha*beta/(1-alpha*beta);

q = @(v,x) 1-exp((-(1-beta)*v+n*log(x)+log(1-x))/(beta*(1-delta)));


s_r=alpha*beta;
s_m=alpha*delta*beta/(1-alpha*beta+alpha*delta*beta);
s_o=alpha*delta*beta/((1-beta+delta*beta)*(1-alpha*beta)+alpha*delta*beta);
 

k_r=s_r^(1/(1-alpha));
k_m=s_m^(1/(1-alpha));
k_o=s_o^(1/(1-alpha));

grid=linspace(0.93*s_m,1.1*s_r,10000)';

N=size(grid,1);

v_o=(alpha*beta*delta/(1-alpha*beta)*log(s_o)+log(1-s_o)-beta*(1-delta)*log(1-s_o))/(1-beta);
v_m=(alpha*beta*delta/(1-alpha*beta)*log(s_m)+log(1-s_m)-beta*(1-delta)*log(1-s_m))/(1-beta);

v_r_1=(alpha*beta*delta/(1-alpha*beta)*log(s_r)+log(1-s_r)-beta*(1-delta)*log(1-s_r))/(1-beta);
v_r_2=beta*v_r_1+delta*alpha*beta/(1-alpha*beta)*log(s_m)+log(1-s_m)-beta*(1-delta)*log(1-s_r);

g=zeros(N,1);
gg=zeros(N,2);
for i=1:N
    
    g(i)= q(v_o,grid(i));
    gg(i,1)= q(0.5*v_m+0.5*v_o,grid(i));
    gg(i,2)= q(0.15*v_m+0.85*v_o,grid(i));
    gg(i,3)= q(1*v_m+0.0*v_o,grid(i));
end


 


figure1 = figure;

% Create axes
axes1 = axes('Parent',figure1);
% Uncomment the following line to preserve the X-limits of the axes


xlim(axes1,[grid(1) grid(N)]);
ylim(axes1,[0.22 0.45]);
box(axes1,'on');
hold(axes1,'all');

% Create multiple lines using matrix input to plot
plot1 = plot(grid,[g,grid],'Parent',axes1);
set(plot1(1),'LineWidth',3,'Color',[    0.8500    0.3250    0.0980] );
 


plot(grid,[gg(:,1)],'LineWidth',2,'LineStyle','--','Color',[0    0.4470    0.74100])
%plot(grid,[gg(:,2),grid],'LineWidth',2,'LineStyle','--','Color',[0 0 0])
plot(grid,[gg(:,3)],'LineWidth',2,'LineStyle','--','Color',[0    0.4470    0.7410])


set(plot1(2),'LineWidth',1,'LineStyle','--','Color','k','DisplayName','45 line');


yL = get(gca,'YLim');
line([s_m s_m],yL,'LineStyle','--','Color','k');
line([q(v_o,s_m) q(v_o,s_m)],yL,'LineStyle','--','Color','k');
line([s_r s_r],yL,'LineStyle','--','Color','k');
line([s_o s_o],yL,'LineStyle','--','Color','k'); 

set(gca,'TickLabelInterpreter', 'latex','FontSize',14);
xticks([s_m  q(v_o,s_m) s_o  s_r ])
xticklabels({'$$s^M$$','$$s_0$$','$$s^*$$','$$s^R$$'})
yticks([] )

xlabel('$$s_t$$','interpreter','latex','FontSize',14);
ylabel('$s_{t+1}$','interpreter','latex','FontSize',14);


I = legend('$$q^*(s)$$','45 degree line');
set(I,'interpreter','latex'); %set Latex interpreter
set(I,'FontWeight','bold','FontSize',14,'Location','NorthWest');
set(I,'FontName','Times New Roman');
set(I,'box','Off');
 